<copyright> MU Assignment.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: Assignment.t,v 1.5 1998/05/25 09:08:58 tiggr Exp $</id>
    </copyright>

implementation class
Assignment: Expression

end;

implementation instance
Assignment
{
  <doc> What is being assigned, which will be a variable or a tuple of
      (tuples and) variables.  </doc>
  Expression lhs;

  <doc> The value being assigned.  </doc>
  public Expression rhs;
}

<doc> Designated initializer.  </doc>
id
  initWithLhs Expression l
	  rhs Expression r
{
  (lhs, rhs) = (l, r);
  = [super initWithType nil];
}

<doc> Emit the {lhs} and {rhs}.  </doc>
OutputStream
  writeFields OutputStream s
{
  = [[super writeFields s] print (" lhs=", lhs, " rhs=", rhs)];
}

end;

/******************** ReturnAssignment ********************/

implementation class
ReturnAssignment: Assignment
{
  <doc> Various boolean flags.  </doc>
  const RA_WITH_JUMP = 1;
}

end;

implementation instance
ReturnAssignment
{
  <doc> Variour boolean flags.  </doc>
  int ra_flags;
}

<doc> Set or clear {RA_WITH_JUMP} in the {ra_flags}.  </doc>
void
  set_with_jump boolean jump_p
{
  ra_flags = jump_p ? ra_flags | RA_WITH_JUMP : ra_flags & ~RA_WITH_JUMP;
}

<doc> Return whether {RA_WITH_JUMP} is set in the {ra_flags}.  </doc>
boolean
  with_jump
{
  = ra_flags & RA_WITH_JUMP != 0;
}

end;
