<copyright> All kinds of MU constants.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1997 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: Constant.t,v 1.10 1998/07/27 15:20:54 tiggr Exp $</id>
    </copyright>

/******************** Constant ********************/

implementation class
Constant: Attribute, Variable, Named

end;

implementation instance
Constant
{
  <doc> This value of this constant.  </doc>
  public Expression value;
}

<doc> Designated initializer.  </doc>
id
  initWithName String n
	 value Expression v
     extension Extension e
{
  value = v;

  [super initWithName n];
  [super initWithExtension e];
  = [super initWithType [value type]];
}

<doc> Pass to {Named}.  </doc>
OutputStream
  writeFields OutputStream s
{
  = [super (Named) writeFields s];
}

end;

/******************** NumberConstant ********************/

implementation class
NumberConstant: Expression

end;

implementation instance
NumberConstant
{
  <doc> The number for which we provide an {Expression} interface.  </doc>
  public Number value;
}

id
  initWithValue Number n
	   type Type t
{
  value = n;
  = [super initWithType t];
}

OutputStream
  writeFields OutputStream s
{
  = [[super writeFields s] print (" value=", value)];
}

end;

/******************** CharConstant ********************/

implementation class
CharConstant: Expression, ByteNumber

end;

implementation instance
CharConstant

id
  init int ch
{
  [super initWithType basic_types_from_kind[BT_BYTE]];
  = [super init ch];
}

OutputStream
  write OutputStream s
{
  = [s print ('\'', [self byteValue], '\'')];
}

end;

/******************** StringConstant ********************/

implementation class
StringConstant: Expression

end;

implementation instance
StringConstant
{
  <doc> The {String} we cover.  </doc>
  public String string;
}

id
  initWithString String s
{
  string = s;

  = [super initWithType string_cst_type];
}

<doc> Return {TRUE}.  </doc>
boolean
  isStringConstant
{
  = TRUE;
}

OutputStream
  write OutputStream s
{
  // The string should be quoted...
  // Thu Jan 23 14:59:59 1997, tiggr@akebono.ics.ele.tue.nl
  = [s print ('"', string, '"')];
}

end;
