<copyright> MU tom lexer.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: LexTom.t,v 1.21 1999/07/30 15:51:18 tiggr Exp $</id>
    </copyright>

implementation class
LexTom: Lexer, ParseTomDefines, mu
{
  static String selector_name;
}

void
  load Array arguments
{
  selector_name = [UniqueString with "selector"];
}

void
  fillTokens
{
  [self addToken ("bind", BIND)];
  [self addToken ("break", BREAK)];
  [self addToken ("catch", CATCH)];
  [self addToken ("class", CLASS)];
  [self addToken ("const", CONST)];
  [self addToken ("continue", CONTINUE)];
  [self addToken ("deferred", DEFERRED)];
  [self addToken ("do", DO)];
  [self addToken ("else", ELSE)];
  [self addToken ("end", END)];
  [self addToken ("extension", EXTENSION)];
  [self addToken ("extern", EXTERN)];
  [self addToken ("for", FOR)];
  [self addToken ("identifier", IDENTIFIER)];
  [self addToken ("if", IF)];
  [self addToken ("implementation", IMPLEMENTATION)];
  [self addToken ("instance", INSTANCE)];
  [self addToken ("interface", INTERFACE)];
  [self addToken ("local", LOCAL)];
  [self addToken ("mutable", MUTABLE)];
  [self addToken ("old", OLD)];
  [self addToken ("posing", POSING)];
  [self addToken ("post", POST)];
  [self addToken ("pre", PRE)];
  [self addToken ("private", PRIVATE)];
  [self addToken ("protected", PROTECTED)];
  [self addToken ("public", PUBLIC)];
  [self addToken ("redeclare", REDECLARE)];
  [self addToken ("redefine", REDEFINE)];
  [self addToken ("return", RETURN)];
  [self addToken ("static", STATIC)];
  [self addToken ("super", SUPER)];
  [self addToken ("unwind", UNWIND)];
  [self addToken ("while", WHILE)];
}

end;

implementation instance
LexTom

int
  block-open
{
  = BLOCK_OPEN;
}

int
  block-close
{
  = BLOCK_CLOSE;
}

int
  andand
{
  = ANDAND;
}

int
  character
{
  = CHARACTER;
}

int
  eq
{
  = EQ;
}

int
  ge
{
  = GE;
}

int
  identifier
{
  // semantics is declared with the wrong type...
  // Fri Oct  4 22:46:20 1996, tiggr@jaguar.ics.ele.tue.nl
  semantics = Any ([UniqueString with String (semantics)]);

  Token t = tokens[semantics];
  if (t != nil)
    return [t token];

  String type = types[semantics];
  if (type != nil)
    return type == selector_name ? SELECTOR : TYPE;

  = IDENTIFIER;
}

int
  implies
{
  = IMPLIES;
}

int
  le
{
  = LE;
}

int
  minusminus
{
  = MINUSMINUS;
}

int
  ne
{
  = NE;
}

int
  number
{
  = NUMBER;
}

int
  oror
{
  = OROR;
}

int
  plusplus
{
  = PLUSPLUS;
}

int
  shl
{
  = SHIFT_LEFT;
}

int
  shr
{
  = SHIFT_RIGHT;
}

int
  lsr
{
  = LOGIC_SHIFT_RIGHT;
}

int
  string
{
  = STRING;
}

int
  div_is
{
  = DIV_IS;
}

int
  add_is
{
  = ADD_IS;
}

int
  implies_is
{
  = IMPLIES_IS;
}

int
  sub_is
{
  = SUB_IS;
}

int
  sc_or_is
{
  = SC_OR_IS;
}

int
  or_is
{
  = OR_IS;
}

int
  sc_and_is
{
  = SC_AND_IS;
}

int
  and_is
{
  = AND_IS;
}

int
  lsr_is
{
  = LSR_IS;
}

int
  shl_is
{
  = SHL_IS;
}

int
  shr_is
{
  = SHR_IS;
}

int
  eor_is
{
  = EOR_IS;
}

int
  mul_is
{
  = MUL_IS;
}

end;
