<copyright> MU TomFile.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996-1998 Pieter J. Schoenmakers.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

    <id>$Id: TomFile.t,v 1.7 1998/07/23 15:50:58 tiggr Exp $</id>
    </copyright>

implementation class
TomFile: Named
{
  <doc> The only file of the builtin unit.  </doc>
  TomFile builtin_file;
}

instance (id)
   named String name
  inUnit Unit unit
{
  = [[self alloc] initWithFilename name unit unit];
}

instance (id)
  builtin_file
{
  if (!builtin_file)
    builtin_file = [[Unit builtin_unit] fileWithName "_builtin_"];
  = builtin_file;
}

end;

implementation instance
TomFile
{
  <doc> The unit containing this file.  </doc>
  public Unit unit;

  <doc> The filename of this file.  </doc>
  public String filename;

  <doc> The extensions (instance-only) contained in this file.  </doc>
  MutableObjectArray elements;
}

<doc> Designated initializer.  </doc>
id
  initWithFilename String n
	      unit Unit u
{
  elements = [MutableObjectArray new];
  filename = n;
  unit = u;

  = [super initWithName [File basename n without-extension: ".t"]];
}

Indexed
  elements
{
  = elements;
}

void
  addElement Extension x
{
  [elements add x];
}

end;
