<doc> Generated by gp.  </doc>
implementation class ParseUnit: gps.Parser, ParseUnitDefines
void
  fill_tokens_by_number
{
tokens_by_number = [MutableObjectArray new];
[tokens_by_number resize 13];
tokens_by_number[10] = "CHARACTER";
tokens_by_number[1] = "CLASS";
tokens_by_number[4] = "FILE";
tokens_by_number[7] = "USES";
tokens_by_number[3] = "EXTENSION";
tokens_by_number[12] = "NUMBER";
tokens_by_number[5] = "IDENTIFIER";
tokens_by_number[9] = "STRING";
tokens_by_number[8] = "POSING";
tokens_by_number[11] = "DOCUMENTATION";
tokens_by_number[2] = "END";
tokens_by_number[6] = "UNIT";
}
end;
implementation instance ParseUnit
{

  <doc> The unit we are reading.  </doc>
  Unit unit;

}



<doc> Designated initializer.  </doc>
id
  init LexUnit l
  unit Unit u
{
  unit = u;

  = [super init l];
}

<doc> Return the file corresponding to the {name}.  The default
    implementation returns the {name}.  </doc>
TomFile
  fileNamed String name
{
  = Any (name);
}

<doc> Note the existence, in the current unit of the extension named
    {extension_name} of the class named {class_name} which itself comes
    from the {unit}.  Both {extension_name} and {unit} are {nil} to
    indicate that the class is part of the current unit.  Furthermore, the
    extension resides in the {file} and it causes the class to pose the
    classes in {posed_classes}.  </doc>
void
       unit String unit_name
      class String class_name
  extension String extension_name
       file TomFile file
     posing Indexed posed_classes
{
  Meta meta = [Meta named (unit_name, class_name) inFile file];

  if (!extension_name)
    {
      if (unit_name)
	{
	  Unit u = [Unit named unit_name];

	  if (!u || u != unit)
	    {
	      [[[self error] print ("class supposedly in other unit")] nl];
	      return;
	    }
	}

      meta = [Meta withName class_name file file];
      [file addElement [meta extensionNamed nil]];
      [unit addMeta meta];
    }
  else
    {
      if (!meta)
	if (!unit_name)
	  [[[self error] print ("nonexisting or ambiguous class `",
				class_name, '\'')] nl];
	else
	  [[[self error] print ("nonexisting class `", unit_name, '.',
				class_name, '\'')] nl];
      else
	{
	  [file addElement [Extension ofMeta meta inFile file
				      name: extension_name]];
	  [Extension ofMeta [meta meta] inFile file name: extension_name];
	}
    }

  if (posed_classes != nil && meta != nil)
    {
      int i, n = [posed_classes length];
      for (i = 0; i < n; i++)
	{
	  Meta posed = posed_classes[i];
	  [self notePoser meta poses posed];
	}
    }
}

<doc> Be notified of the {poser} posing as its superclass {posed}.
    The default implementation does nothing.  </doc>
void
  notePoser Meta poser
      poses Meta posed
{
}



(String)(name)
  extension
{
 if (trace) [[err print "entering rule: extension"] nl];
  {
    {
     [self term '('];
    }
    {name = [lex semantics];
     [self term IDENTIFIER];
    }
    {
     [self term ')'];
    }
  }
}
(String, String)(u, m)
  meta_name
{
 if (trace) [[err print "entering rule: meta_name"] nl];
  {m = [lex semantics];
   [self term IDENTIFIER];
  }
 if (token == '.')
  {
    {
     [self term '.'];
    }
    {u = [lex semantics];
     [self term IDENTIFIER];
     
		  (u, m) = (m, u);
		
    }
  }
}
void
  top
{
 if (trace) [[err print "entering rule: top"] nl];
 if (token == FILE)
  {
    {
     [self a_file];
    }
  }
 else if (token == USES)
  {
    {
     [self uses];
    }
  }
 else [self fatalError];
}
void
  uses_unit
{
 if (trace) [[err print "entering rule: uses_unit"] nl];
 
	  String other;
	
  {other = [lex semantics];
   [self term IDENTIFIER];
   
		  [unit uses other];
		
  }
}
void
  a_file
{
 if (trace) [[err print "entering rule: a_file"] nl];
 
	  String filename;
	  TomFile file;
	
  {
   [self term FILE];
  }
  {filename = [lex semantics];
   [self term STRING];
   
		  filename = [File express-filename filename
				   relative-to [unit directory]];
		  file = [unit fileWithName filename];
		
  }
  {
   [self term '{'];
  }
 while (token == CLASS || token == EXTENSION)
  {
   [self decl (file)];
  }
  {
   [self term '}'];
  }
}
void
  decl(TomFile)(file)
{
 if (trace) [[err print "entering rule: decl"] nl];
 
	  String ext_name, meta_name, unit_name;
	  String posing_unit_name, posing_meta_name;
	
  {
   if (token == CLASS)
    {
      {
       [self term CLASS];
      }
    }
   else if (token == EXTENSION)
    {
      {
       [self term EXTENSION];
      }
    }
   else [self fatalError];
  }
  {
   (unit_name, meta_name) = [self meta_name];
  }
 if (token == '(')
  {
   (ext_name) = [self extension];
  }
 if (token == POSING)
  {
    {
     [self term POSING];
    }
    {
     (posing_unit_name, posing_meta_name) = [self meta_name];
    }
  }
  {
   
		  Indexed posings;

		  if (posing_meta_name != nil)
		    {
		      Meta m = [Meta named (posing_unit_name, posing_meta_name)
				     inFile file];
		      posings = [MutableObjectArray with m];
		    }		    

		  [self unit unit_name class meta_name
			extension ext_name file file posing posings];
		
   [self term ';'];
  }
}
void
  file
{
 gps.Parser previous_parser = current_parser;
 current_parser = self;
 unwind (current_parser = previous_parser)
 ({
  [self nextToken];
  if (trace) [[err print "entering rule: file"] nl];
  
	  String unit_name;
	
   {
    [self term UNIT];
   }
   {unit_name = [lex semantics];
    [self term IDENTIFIER];
    
		  if (![unit_name equal [unit name]])
		    [[[self error] print ("unit name `", unit_name,
					  "' does not match expected `",
					  [unit name], '\'')] nl];
		  [unit uses [[Unit builtin_unit] name]];
		
   }
  while (token == FILE || token == USES)
   {
    [self top];
   }
   {
    [self term END];
   }
   {
    [self term ';'];
   }
  if (token != EOF) [self fatalError];
 });
}
void
  uses
{
 if (trace) [[err print "entering rule: uses"] nl];
  {
   [self term USES];
  }
  {
   [self uses_unit];
  }
 while (token == ',')
  {
    {
     [self term ','];
    }
    {
     [self uses_unit];
    }
  }
  {
   [self term ';'];
  }
}
end;
